
#include "ext.h"							
#include "ext_obex.h"

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

typedef struct _flop {
	t_object        ob;
    t_dictionary    *data;
	void            *outlet;
	} t_flop;

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

void *flop_new                  (t_symbol *s, long argc, t_atom *argv);
void flop_appendtodictionary    (t_flop *x, t_dictionary *bd);
void flop_free					(t_flop *x);
void flop_bang					(t_flop *x);

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

static t_class *flop_class;

int main (void)
{	
    t_class *c = NULL;
    
    c = class_new ("flop", (method)flop_new, (method)flop_free, (long)sizeof(t_flop), 0L, A_GIMME, 0);
    
    class_addmethod	(c, (method)flop_appendtodictionary,    "appendtodictionary", A_CANT, 0);
    class_addmethod (c, (method)flop_bang,                  "bang", 0);
    
    class_register (CLASS_BOX, c);
    
    flop_class = c;
    
    return 0;
}

void *flop_new (t_symbol *s, long argc, t_atom *argv)
{
    t_flop *x = NULL;
    
    if (x = (t_flop *)object_alloc (flop_class)) {	
    //
    t_dictionary *d = NULL; 
        
    if (d = (t_dictionary *)gensym ("#D")->s_thing) {
        if (dictionary_entryisdictionary (d, gensym ("toto"))) {
        
            dictionary_getdictionary (d, gensym ("toto"), (t_object **)&x->data);
            dictionary_chuckentry    (d, gensym ("toto"));
            
        } else {
            x->data = dictionary_new ( );
        }
    }
    //
    }
            
    return x;
}

void flop_appendtodictionary (t_flop *x, t_dictionary *d)
{
    if (d) {
        t_dictionary *temp = NULL;
        
        temp = dictionary_new ( );
        dictionary_copyunique (temp, x->data);
        dictionary_appenddictionary (d, gensym("toto"), (t_object *)temp);
    }
}
	
void flop_free (t_flop *x)
{ 
    object_free (x->data);
}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
	
void flop_bang (t_flop *x)
{	
    long k = 0;
    
    if (dictionary_hasentry (x->data, gensym ("test"))) {
    //
    dictionary_getlong (x->data, gensym ("test"), &k);
    k++; 
    dictionary_appendlong (x->data, gensym ("test"), k);
    //
    
    } else {
        dictionary_appendlong (x->data, gensym ("test"), k);
    }
    
    post ("? %ld", k);
}

// -------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------:x